Index: trunk/MagicSoft/Mars/macros/CT1Analysis.C
===================================================================
--- trunk/MagicSoft/Mars/macros/CT1Analysis.C	(revision 2163)
+++ trunk/MagicSoft/Mars/macros/CT1Analysis.C	(revision 2167)
@@ -633,5 +633,5 @@
     //     fPadFlag = 2   get Sigma    from fHSigmaPixTheta
     
-    MPadSchweizer padthomas("MPadSchweizer","Task for the padding (Schweizer)");
+    MCT1PadSchweizer padthomas("MCT1PadSchweizer","Task for the padding (Schweizer)");
     padthomas.SetHistograms(fHSigmaTheta, fHSigmaPixTheta, fHDiffPixTheta,
                             fHIdBlindPixels, fHNBlindPixels);
Index: trunk/MagicSoft/Mars/macros/ONOFFCT1Analysis.C
===================================================================
--- trunk/MagicSoft/Mars/macros/ONOFFCT1Analysis.C	(revision 2163)
+++ trunk/MagicSoft/Mars/macros/ONOFFCT1Analysis.C	(revision 2167)
@@ -282,6 +282,6 @@
     //--------------------------------------------------
     // type of data to be padded 
-    //TString typeInput = "ON";
-    TString typeInput = "OFF";
+    TString typeInput = "ON";
+    //TString typeInput = "OFF";
     //TString typeInput = "MC";
     gLog << "typeInput = " << typeInput << endl;
@@ -312,6 +312,6 @@
     //                       and merge these histograms
 
-    MPadONOFF pad;
-    pad.SetName("MPadONOFF");
+    MCT1PadONOFF pad;
+    pad.SetName("MCT1PadONOFF");
     pad.SetPadFlag(1);
     pad.SetDataType(typeInput);
@@ -334,4 +334,8 @@
       MCT1ReadPreProc readON(fileON);
 
+      MFCT1SelBasic selthetaon;
+      selthetaon.SetCuts(-100.0, 29.5, 35.5);
+      MContinue contthetaon(&selthetaon);
+
       MBlindPixelCalc blindon;
       blindon.SetUseBlindPixels();
@@ -361,4 +365,5 @@
     
       tliston.AddToList(&readON);
+      //tliston.AddToList(&contthetaon);
 
       tliston.AddToList(&blindon);
@@ -375,5 +380,5 @@
 
       Int_t maxeventson = -1;
-      //Int_t maxeventson = 1000;
+      //Int_t maxeventson = 20000;
       if ( !evtloopon.Eventloop(maxeventson) )
           return;
@@ -403,4 +408,8 @@
 
       MCT1ReadPreProc readOFF(fileOFF);
+
+      MFCT1SelBasic selthetaoff;
+      selthetaoff.SetCuts(-100.0, 29.5, 35.5);
+      MContinue contthetaoff(&selthetaoff);
 
       MBlindPixelCalc blindoff;
@@ -434,4 +443,5 @@
     
       tlistoff.AddToList(&readOFF);
+      //tlistoff.AddToList(&contthetaoff);
 
       tlistoff.AddToList(&blindoff);
@@ -448,5 +458,5 @@
 
       Int_t maxeventsoff = -1;
-      //Int_t maxeventsoff = 1000;
+      //Int_t maxeventsoff = 20000;
       if ( !evtloopoff.Eventloop(maxeventsoff) )
           return;
@@ -471,5 +481,4 @@
       gLog << "=====================================================" << endl;
 
-      gLog << "Merge the ON and OFF histograms and define the histograms for the padding :" << endl;
       pad.MergeHistograms(sigthon,     sigthoff,
                           sigpixthon,  sigpixthoff,
@@ -477,8 +486,4 @@
                           blindidthon, blindidthoff,
                           blindnthon,  blindnthoff);
-      gLog << "The histograms for the padding have been defined" << endl;
-      gLog << "=====================================================" << endl;
-
-
 
       if (WPad)
@@ -520,4 +525,8 @@
     MCT1ReadPreProc read(filenamein);
 
+    MFCT1SelBasic seltheta;
+    seltheta.SetCuts(-100.0, 29.5, 35.5);
+    MContinue conttheta(&seltheta);
+
     if (typeInput ==  "ON")
     {
@@ -526,6 +535,11 @@
     }
 
+    MBlindPixelCalc blindbeforepad;
+    blindbeforepad.SetUseBlindPixels();
+    blindbeforepad.SetName("BlindBeforePadding");
+
     MBlindPixelCalc blind;
     blind.SetUseBlindPixels();
+    blind.SetName("BlindAfterPadding");
 
     MFCT1SelBasic selbasic;
@@ -609,4 +623,7 @@
     
     tliston.AddToList(&read);
+    //tliston.AddToList(&conttheta);
+
+    tliston.AddToList(&blindbeforepad);
     tliston.AddToList(&pad);
     if (typeInput ==  "ON")
@@ -644,6 +661,6 @@
     //  evtloop.Write();
 
-    //Int_t maxevents = -1;
-    Int_t maxevents = 10000;
+    Int_t maxevents = -1;
+    //Int_t maxevents = 1000;
     if ( !evtloop.Eventloop(maxevents) )
         return;