Index: trunk/MagicSoft/Mars/meventdisp/MGCamDisplay.cc
===================================================================
--- trunk/MagicSoft/Mars/meventdisp/MGCamDisplay.cc	(revision 2205)
+++ trunk/MagicSoft/Mars/meventdisp/MGCamDisplay.cc	(revision 2210)
@@ -36,9 +36,9 @@
 #include "MEvtLoop.h"            // MEvtLoop::GetParList
 #include "MTaskList.h"           // MTaskList::AddToList
-#include "MCamDisplay.h"         // MCamDisplay
+#include "MHCamera.h"         // MHCamera
 #include "MHillasCalc.h"         // MHillasCalc
 #include "MHillasSrcCalc.h"      // MHillasSrcCalc
 #include "MPedestalCam.h"        // MPedestalCam
-#include "MCerPhotCalc.h"        // MCerPhotCalc
+#include "MCerPhotAnal2.h"       // MCerPhotAnal
 #include "MMcPedestalCopy.h"     // MMcPedestalCopy
 #include "MMcPedestalNSBAdd.h"   // MMcPedestalNSBAdd
@@ -120,5 +120,5 @@
     MMcPedestalCopy   *pcopy = new MMcPedestalCopy;
     MMcPedestalNSBAdd *pdnsb = new MMcPedestalNSBAdd;
-    MCerPhotCalc      *ncalc = new MCerPhotCalc;
+    MCerPhotAnal2     *ncalc = new MCerPhotAnal2;
     MClone            *clone = new MClone("MCerPhotEvt");
     MImgCleanStd      *clean = new MImgCleanStd;
@@ -177,5 +177,5 @@
     {
         fCanvas2[i]->cd();
-        fDisplay[i]  = new MCamDisplay(geom);
+        fDisplay[i]  = new MHCamera(*geom);
         fDisplay[i]->Draw();
         fDisplay[i]->AddNotify(*(MCamEvent*)GetParList()->FindObject("MRawEvtData"));
@@ -249,9 +249,9 @@
     const MPedestalCam *ped   = (MPedestalCam*)plist->FindObject("MPedestalCam");
 
-    fDisplay[0]->Fill((MCamEvent&)*evt, 0);
-    fDisplay[1]->Fill((MCamEvent&)*evt, 1);
-    fDisplay[2]->Fill((MCamEvent&)*evt, 2);
+    fDisplay[0]->SetCamContent((MCamEvent&)*evt, 0);
+    fDisplay[1]->SetCamContent((MCamEvent&)*evt, 1);
+    fDisplay[2]->SetCamContent((MCamEvent&)*evt, 2);
     fDisplay[3]->FillLevels(*evt, *clean);
-    fDisplay[4]->Fill((MCamEvent&)*ped);
+    fDisplay[4]->SetCamContent((MCamEvent&)*ped);
 
     for (int i=0; i<5; i++)
Index: trunk/MagicSoft/Mars/meventdisp/MGCamDisplay.h
===================================================================
--- trunk/MagicSoft/Mars/meventdisp/MGCamDisplay.h	(revision 2205)
+++ trunk/MagicSoft/Mars/meventdisp/MGCamDisplay.h	(revision 2210)
@@ -9,5 +9,5 @@
 
 class MGeomCam;
-class MCamDisplay;
+class MHCamera;
 
 class MGCamDisplay : public MGEvtDisplay
@@ -19,5 +19,5 @@
     TGListBox   *fPixelList;
 
-    MCamDisplay *fDisplay[5];
+    MHCamera *fDisplay[5];
     TCanvas     *fCanvas2[5];
 
Index: trunk/MagicSoft/Mars/meventdisp/MGEvtDisplay.cc
===================================================================
--- trunk/MagicSoft/Mars/meventdisp/MGEvtDisplay.cc	(revision 2205)
+++ trunk/MagicSoft/Mars/meventdisp/MGEvtDisplay.cc	(revision 2210)
@@ -46,5 +46,5 @@
 #include "MTaskList.h"
 #include "MEvtLoop.h"
-#include "MCamDisplay.h"
+#include "MHCamera.h"
 #include "MReadMarsFile.h"
 #include "MGeomCamMagic.h"
@@ -279,5 +279,5 @@
     AddTab("Geometry");
     MGeomCamMagic geom;
-    MCamDisplay *display = new MCamDisplay(&geom);
+    MHCamera *display = new MHCamera(geom);
     display->Draw();
     display->DrawPixelNumbers();
@@ -648,5 +648,4 @@
         {
         case kTE_ENTER:
-        case kCM_BUTTON:
             if (parm1==kClose)
             {
@@ -664,17 +663,4 @@
                     ReadinEvent();
                 return kTRUE;
-
-            case kCM_BUTTON:
-                switch (parm1)
-                {
-                case kEvtPrev:
-                    ReadinEvent(-1);
-                    return kTRUE;
-
-                case kEvtNext:
-                    ReadinEvent(+1);
-                    return kTRUE;
-                }
-                return kTRUE;
             }
             return kTRUE;
@@ -685,4 +671,26 @@
         switch (GET_SUBMSG(msg))
         {
+        case kCM_BUTTON:
+            if (parm1==kClose)
+            {
+                CloseWindow();
+                return kTRUE;
+            }
+
+            if (!fInitOk)
+                return kTRUE;
+
+            switch (parm1)
+            {
+            case kEvtPrev:
+                ReadinEvent(-1);
+                return kTRUE;
+
+            case kEvtNext:
+                ReadinEvent(+1);
+                return kTRUE;
+            }
+            return kTRUE;
+
         case kCM_MENU:
             switch (parm1)